diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index 5f2030421..60e0f15ca 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -1,15 +1,14 @@
 package net.minecraft.client.render;
 
-import net.minecraft.client.render.block.model.BlockModel;
-import net.minecraft.client.render.tessalator.Tessellator;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
@@ -71,59 +70,79 @@ public class RenderBlocks
         return blockAccess.getBrightness(x, y, z, Block.lightEmission[id]);
     }
 
-    public void renderBlockFallingSand(Tessellator tessellator, BlockModel<Block> blockModel, Block block, World world, int i, int j, int k)
-    {
-        float f = 0.5F;
-        float f1 = 1.0F;
-        float f2 = 0.8F;
-        float f3 = 0.6F;
-        tessellator.startDrawingQuads();
-        float f4 = getBlockBrightness(world, i, j, k);
-        float f5 = getBlockBrightness(world, i, j - 1, k);
-        int meta = world.getBlockMetadata(i, j, k);
-        if(f5 < f4)
-        {
-            f5 = f4;
-        }
-        tessellator.setColorOpaque_F(f * f5, f * f5, f * f5);
-        renderBottomFace(tessellator, block, -0.5D, -0.5D, -0.5D, blockModel.getBlockTextureFromSideAndMetadata(Side.BOTTOM, meta));
-        f5 = getBlockBrightness(world, i, j + 1, k);
-        if(f5 < f4)
-        {
-            f5 = f4;
-        }
-        tessellator.setColorOpaque_F(f1 * f5, f1 * f5, f1 * f5);
-        renderTopFace(tessellator, block, -0.5D, -0.5D, -0.5D, blockModel.getBlockTextureFromSideAndMetadata(Side.TOP, meta));
-        f5 = getBlockBrightness(world, i, j, k - 1);
-        if(f5 < f4)
-        {
-            f5 = f4;
-        }
-        tessellator.setColorOpaque_F(f2 * f5, f2 * f5, f2 * f5);
-        renderNorthFace(tessellator, block, -0.5D, -0.5D, -0.5D, blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
-        f5 = getBlockBrightness(world, i, j, k + 1);
-        if(f5 < f4)
-        {
-            f5 = f4;
-        }
-        tessellator.setColorOpaque_F(f2 * f5, f2 * f5, f2 * f5);
-        renderSouthFace(tessellator, block, -0.5D, -0.5D, -0.5D, blockModel.getBlockTextureFromSideAndMetadata(Side.SOUTH, meta));
-        f5 = getBlockBrightness(world, i - 1, j, k);
-        if(f5 < f4)
-        {
-            f5 = f4;
-        }
-        tessellator.setColorOpaque_F(f3 * f5, f3 * f5, f3 * f5);
-        renderWestFace(tessellator, block, -0.5D, -0.5D, -0.5D, blockModel.getBlockTextureFromSideAndMetadata(Side.WEST, meta));
-        f5 = getBlockBrightness(world, i + 1, j, k);
-        if(f5 < f4)
-        {
-            f5 = f4;
-        }
-        tessellator.setColorOpaque_F(f3 * f5, f3 * f5, f3 * f5);
-        renderEastFace(tessellator, block, -0.5D, -0.5D, -0.5D, blockModel.getBlockTextureFromSideAndMetadata(Side.EAST, meta));
-        tessellator.draw();
-    }
+	public void renderBlockFallingSand(Tessellator tessellator, BlockModel<Block> blockModel, Block block, WorldSource world, int x, int y, int z) {
+		final boolean lightmap = LightmapHelper.isLightmapEnabled();
+		
+		float sideBottom = 0.5f;
+		float sideTop = 1.0f;
+		float sideNorthSouth = 0.8f;
+		float sideEastWest = 0.6f;
+		
+		tessellator.startDrawingQuads();
+		
+		int meta = world.getBlockMetadata(x, y, z);
+		
+		final float brightnessInside = lightmap ? 1.0f : getBlockBrightness(world, x, y, z);
+		float brightness = 1.0f;
+		
+		final int lmcInside = lightmap ? block.getLightmapCoord(world, x, y, z) : 0;
+		
+		// Bottom
+		if(lightmap) {
+			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x, y - 1, z)));
+		}else {
+			brightness = Math.max(getBlockBrightness(world, x, y - 1, z), brightnessInside);
+		}
+		tessellator.setColorOpaque_F(sideBottom * brightness, sideBottom * brightness, sideBottom * brightness);
+		renderBottomFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.BOTTOM, meta));
+		
+		// Top
+		if(lightmap) {
+			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x, y + 1, z)));
+		}else {
+			brightness = Math.max(getBlockBrightness(world, x, y + 1, z), brightnessInside);	
+		}
+		tessellator.setColorOpaque_F(sideTop * brightness, sideTop * brightness, sideTop * brightness);
+		renderTopFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.TOP, meta));
+		
+		// North
+		if(lightmap) {
+			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x, y, z - 1)));
+		}else {
+			brightness = Math.max(getBlockBrightness(world, x, y, z - 1), brightnessInside);
+		}
+		tessellator.setColorOpaque_F(sideNorthSouth * brightness, sideNorthSouth * brightness, sideNorthSouth * brightness);
+		renderNorthFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
+		
+		// South
+		if(lightmap) {
+			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x, y, z + 1)));
+		}else {
+			brightness = Math.max(getBlockBrightness(world, x, y, z + 1), brightnessInside);
+		}
+		tessellator.setColorOpaque_F(sideNorthSouth * brightness, sideNorthSouth * brightness, sideNorthSouth * brightness);
+		renderSouthFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.SOUTH, meta));
+		
+		// West
+		if(lightmap) {
+			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x - 1, y, z)));
+		}else {
+			brightness = Math.max(getBlockBrightness(world, x - 1, y, z), brightnessInside);
+		}
+		tessellator.setColorOpaque_F(sideEastWest * brightness, sideEastWest * brightness, sideEastWest * brightness);
+		renderWestFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.WEST, meta));
+		
+		// East
+		if(lightmap) {
+			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x + 1, y, z)));
+		}else {
+			brightness = Math.max(getBlockBrightness(world, x + 1, y, z), brightnessInside);
+		}
+		tessellator.setColorOpaque_F(sideEastWest * brightness, sideEastWest * brightness, sideEastWest * brightness);
+		renderEastFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.EAST, meta));
+		
+		tessellator.draw();
+	}
 
     public boolean renderStandardBlock(Tessellator tessellator, BlockModel<Block> blockModel, Block block, int x, int y, int z)
     {
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 3d5a44b5a..17ed21139 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1604,17 +1604,16 @@ public class RenderGlobal
     }
     
     @Override
-	public void addParticle(String particleKey, double x, double y, double z, double motionX, double motionY, double motionZ)
+	public void addParticle(String particleKey, double x, double y, double z, double motionX, double motionY, double motionZ, int data)
     {
-        addParticle(particleKey, x, y, z, motionX, motionY, motionZ, 16D);
+        addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data, 16D);
     }
 
     @Override
 	public void addParticle(String particleId, double x, double y, double z,
-                            double motionX, double motionY, double motionZ, double maxDistance)
+                            double motionX, double motionY, double motionZ, int data, double maxDistance)
     {
-        if(mc == null || mc.activeCamera == null || mc.effectRenderer == null)
-        {
+        if(mc == null || mc.activeCamera == null || mc.effectRenderer == null) {
             return;
         }
         double d6 = mc.activeCamera.getX() - x;
@@ -1624,7 +1623,7 @@ public class RenderGlobal
         {
             return;
         }
-        EntityFX fx = ParticleDispatcher.getInstance().getDispatch(particleId).newParticle(worldObj, x, y, z, motionX, motionY, motionZ);
+        EntityFX fx = ParticleDispatcher.getInstance().getDispatch(particleId).newParticle(worldObj, x, y, z, motionX, motionY, motionZ, data);
         if (fx != null){
             mc.effectRenderer.addEffect(fx);
         }
@@ -1633,9 +1632,6 @@ public class RenderGlobal
     @Override
     public void allChanged()
     {
-    	if(LightmapHelper.isLightmapEnabled()) {
-    		return;
-    	}
         for (ChunkRenderer chunkRenderer : chunkRenderers)
         {
             if (chunkRenderer.isChunkLit && !chunkRenderer.needsUpdate)
@@ -1695,7 +1691,7 @@ public class RenderGlobal
                 double d7 = (double)j1 * d3 + random.nextGaussian() * 0.01D;
                 double d8 = -0.03D + random.nextGaussian() * 0.01D;
                 double d9 = (double)k1 * d3 + random.nextGaussian() * 0.01D;
-                addParticle("smoke", d4, d5, d6, d7, d8, d9);
+                addParticle("smoke", d4, d5, d6, d7, d8, d9, 0);
             }
 
             break;
diff --git a/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java b/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
index 8a72d7ce2..fd8c3b159 100644
--- a/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
@@ -80,9 +80,13 @@ public class TileEntityRenderDispatcher
     {
         if(tileEntity.getDistanceFrom(viewLerpPosX, viewLerpPosY, viewLerpPosZ) < 4096D)
         {
-            float brightness = worldObj.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
-            if(Global.accessor.isFullbrightEnabled()) {
-            	brightness = 1.0f;
+            float brightness = 1.0f;
+            if(LightmapHelper.isLightmapEnabled()) {
+            	LightmapHelper.setLightmapCoord(worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
+            }else if(Global.accessor.isFullbrightEnabled()) {
+            	
+            }else {
+            	brightness = worldObj.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
             }
             GL11.glColor3f(brightness, brightness, brightness);
             renderTileEntity(tessellator,
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
index 6ca6f3d1a..9a0295cdc 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
@@ -30,7 +30,7 @@ public class BlockColorTallGrass
         localHumidity += offsetH;
 
         int baseGrassColor = ColorizerGrass.getGrassColor(localTemperature, localHumidity);
-        if (world.getBlockBiome(x, y - 1, z) == Biomes.OVERWORLD_CAATINGA) {
+        if (world.getBlockBiome(x, y - 1, z) == Biomes.OVERWORLD_CAATINGA || world.getBlockBiome(x, y - 1, z) == Biomes.OVERWORLD_CAATINGA_PLAINS) {
 
             Season season = world.getSeasonManager().getCurrentSeason();
             if (season != null) {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index c248b49e6..7f9412778 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -176,6 +176,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelAxisAligned<>(Block.logCherry).withTextures("minecraft:block/log_cherry_top", "minecraft:block/log_cherry_side"));
         addDispatch(new BlockModelAxisAligned<>(Block.logEucalyptus).withTextures("minecraft:block/log_eucalyptus_top", "minecraft:block/log_eucalyptus_side"));
         addDispatch(new BlockModelAxisAligned<>(Block.logOakMossy).withTextures("minecraft:block/log_oak_mossy_top", "minecraft:block/log_oak_mossy_side"));
+        addDispatch(new BlockModelAxisAligned<>(Block.logBrazilwood).withTextures("minecraft:block/log_brazilwood_top", "minecraft:block/log_brazilwood_side"));
 
         addDispatch(new BlockModelLeaves<>(Block.leavesOak, "minecraft:block/leaves_oak"));
         addDispatch(new BlockModelLeaves<>(Block.leavesOakRetro, "minecraft:block/leaves_oak_retro"));
@@ -186,7 +187,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelLeaves<>(Block.leavesShrub, "minecraft:block/leaves_shrub"));
         addDispatch(new BlockModelCherryLeavesBloom<>(Block.leavesCherryFlowering));
         addDispatch(new BlockModelCacaoLeaves<>(Block.leavesCacao));
-        addDispatch(new BlockModelLeaves<>(Block.leavesCaatinga, "minecraft:block/leaves_caatinga"));
+        addDispatch(new BlockModelLeaves<>(Block.leavesCaatinga, "minecraft:block/leaves_oak"));
 
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingOak).withTextures("minecraft:block/sapling_oak"));
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingOakRetro).withTextures("minecraft:block/sapling_oak_retro"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index 8800d2450..bb44de04c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -8,7 +8,7 @@ import net.minecraft.core.world.WorldSource;
 
 public class BlockModelLeaves<T extends Block> extends BlockModelStandard<T> {
     protected static boolean fancyGraphics;
-    private final IconCoordinate fancyLeavesTexture;
+    protected final IconCoordinate fancyLeavesTexture;
 
     public BlockModelLeaves(Block block, String leavesTex) {
         super(block);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesOverlay.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesOverlay.java
new file mode 100644
index 000000000..9265257cb
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesOverlay.java
@@ -0,0 +1,66 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import org.lwjgl.opengl.GL11;
+
+public class BlockModelLeavesOverlay<T extends Block> extends BlockModelLeaves<T> {
+    protected final IconCoordinate overlayTexture;
+    public BlockModelLeavesOverlay(Block block, String leavesTex, String overlayTex) {
+        super(block, leavesTex);
+        overlayTexture = TextureRegistry.getTexture(overlayTex);
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        super.render(tessellator, x, y, z);
+
+        renderBlocks.overrideBlockTexture = overlayTexture;
+        renderStandardBlock(tessellator, block, x, y, z, 1.0f, 1.0f, 1.0f);
+        renderBlocks.overrideBlockTexture = null;
+
+        return true;
+    }
+    @Override
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha);
+        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
+
+        IconCoordinate overlayCoord = overlayTexture;
+        GL11.glColor4f(brightness, brightness, brightness, alpha);
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, -1F, 0.0F);
+        renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 1.0F, 0.0F);
+        renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 0.0F, -1F);
+        renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 0.0F, 1.0F);
+        renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(-1F, 0.0F, 0.0F);
+        renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        tessellator.draw();
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(1.0F, 0.0F, 0.0F);
+        renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        tessellator.draw();
+
+        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
index 9a859dc47..83cb67696 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.item.model;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.ItemRenderer;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.MapItemRenderer;
 import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.tessalator.Tessellator;
@@ -26,10 +27,20 @@ public class ItemModelMap extends ItemModelStandard {
 
     @Override
     public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, EntityPlayer player, ItemStack stack, float partialTick) {
+    	int blockX = MathHelper.floor_double(player.x);
+    	int blockY = MathHelper.floor_double(player.y);
+    	int blockZ = MathHelper.floor_double(player.z);
+    	
         // Apply appropriate brightness
-        float brightness = mc.theWorld.getLightBrightness(MathHelper.floor_double(player.x), MathHelper.floor_double(player.y), MathHelper.floor_double(player.z));
-        if (mc.fullbright) brightness = 1.0f;
-        GL11.glColor4f(brightness, brightness, brightness, 1f);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	LightmapHelper.setLightmapCoord(mc.theWorld.getLightmapCoord(blockX, blockY, blockZ, 0));
+        }else if(mc.fullbright) {
+        	
+        }else {
+        	brightness = mc.theWorld.getLightBrightness(blockX, blockY, blockZ);
+        }
+        GL11.glColor4f(brightness, brightness, brightness, 1.0f);
 
         final float rotationPitch = player.xRotO + (player.xRot - player.xRotO) * partialTick;
         final float swingProgress = player.getSwingProgress(partialTick);
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index dd6766d9f..29ddb3e2d 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -111,9 +111,19 @@ public class ItemModelStandard extends ItemModel{
 
     @Override
     public void renderItemThirdPerson(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform) {
-        float brightness = entity.getBrightness(1f);
-        if (mc.fullbright || itemfullBright) brightness = 1.0f;
-
+        float brightness = 1.0f;
+        if(mc.fullbright || itemfullBright || LightmapHelper.isLightmapEnabled()) {
+        	if(LightmapHelper.isLightmapEnabled()) {
+            	int lightmapCoord = entity.getLightmapCoord(1.0f);
+            	if(itemfullBright) {
+            		lightmapCoord = LightmapHelper.setBlocklightValue(lightmapCoord, 15);
+            	}
+            	LightmapHelper.setLightmapCoord(lightmapCoord);	
+        	}
+        }else {
+        	brightness = entity.getBrightness(1.0f);
+        }
+        
         GL11.glTranslatef(-0.0625F, 0.4375F, 0.0625F);
         heldTransformThirdPerson(renderer, entity, itemstack);
         renderItem(tessellator, renderer, itemstack, entity, brightness, handheldTransform);
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 334b525cb..936dd5b3b 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -999,6 +999,8 @@ public class Block
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
     public static final Block logOakMossy = new BlockLog("log.oak.mossy", 285).withHardness(2.0F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
+    public static final Block logBrazilwood = new BlockLog("log.brazilwood", 286).withHardness(2.0F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
 
     public static final Block leavesOak = new BlockLeavesOak("leaves.oak", 290).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.SHEARS_DO_SILK_TOUCH, BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
@@ -1060,6 +1062,8 @@ public class Block
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
     public static final Block flowerLightBlue = new BlockFlower("flower.lightblue", 334).setKilledByWeather().setBonemealable().withHardness(0.0F)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+    public static final Block flowerOrange = new BlockFlower("flower.orange", 335).setKilledByWeather().setBonemealable().withHardness(0.0F)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
 
     public static final Block mushroomBrown = new BlockMushroom("mushroom.brown", 340).withHardness(0.0F).withLightEmission(0.125F)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
diff --git a/src/main/java/net/minecraft/core/block/BlockBlastFurnace.java b/src/main/java/net/minecraft/core/block/BlockBlastFurnace.java
index d26144a94..0e19b5db9 100644
--- a/src/main/java/net/minecraft/core/block/BlockBlastFurnace.java
+++ b/src/main/java/net/minecraft/core/block/BlockBlastFurnace.java
@@ -1,15 +1,15 @@
 package net.minecraft.core.block;
 
-import java.util.Random;
-
 import net.minecraft.core.Global;
-import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityBlastFurnace;
+import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
+import java.util.Random;
+
 // Referenced classes of package net.minecraft.src:
 //            BlockContainer, Material, Block, World,
 //            IBlockAccess, TileEntityFurnace, EntityPlayer, TileEntity,
@@ -68,23 +68,23 @@ public class BlockBlastFurnace extends BlockFurnace
         float f4 = rand.nextFloat() * 0.6F - 0.3F;
         if(l == 4)
         {
-            world.spawnParticle("smoke", posX - f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("largeSmoke", posX - f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", posX - f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("largeSmoke", posX - f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D, 0);
         } else
         if(l == 5)
         {
-            world.spawnParticle("smoke", posX + f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("largeSmoke", posX + f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", posX + f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("largeSmoke", posX + f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D, 0);
         } else
         if(l == 2)
         {
-            world.spawnParticle("smoke", posX + f4, posY, posZ - f3, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("largeSmoke", posX + f4, posY, posZ - f3, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", posX + f4, posY, posZ - f3, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("largeSmoke", posX + f4, posY, posZ - f3, 0.0D, 0.0D, 0.0D, 0);
         } else
         if(l == 3)
         {
-            world.spawnParticle("smoke", posX + f4, posY, posZ + f3, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("largeSmoke", posX + f4, posY, posZ + f3, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", posX + f4, posY, posZ + f3, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("largeSmoke", posX + f4, posY, posZ + f3, 0.0D, 0.0D, 0.0D, 0);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockCandle.java b/src/main/java/net/minecraft/core/block/BlockCandle.java
index 9000dc5b2..fe9b40831 100644
--- a/src/main/java/net/minecraft/core/block/BlockCandle.java
+++ b/src/main/java/net/minecraft/core/block/BlockCandle.java
@@ -72,8 +72,8 @@ public class BlockCandle extends Block
         double d = x + 0.5D;
         double d1 = y + 0.7D;
         double d2 = z + 0.5D;
-        world.spawnParticle("smoke", d, d1, d2, 0.0D, 0.0D, 0.0D);
-        world.spawnParticle("soulflame", d, d1, d2, 0.0D, 0.0D, 0.0D);
+        world.spawnParticle("smoke", d, d1, d2, 0.0D, 0.0D, 0.0D, 0);
+        world.spawnParticle("soulflame", d, d1, d2, 0.0D, 0.0D, 0.0D, 0);
     }
 
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockFire.java b/src/main/java/net/minecraft/core/block/BlockFire.java
index ce2714704..af484cb45 100644
--- a/src/main/java/net/minecraft/core/block/BlockFire.java
+++ b/src/main/java/net/minecraft/core/block/BlockFire.java
@@ -87,7 +87,7 @@ public class BlockFire extends Block {
 	{
 		for (int i = 0; i < 8; i++)
 		{
-			world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + 0.5D, (double)z + Math.random(), 0.0D, 0.0D, 0.0D);
+			world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + 0.5D, (double)z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
 		}
 	}
 
@@ -299,7 +299,7 @@ public class BlockFire extends Block {
 				double f = (double) x + rand.nextFloat();
 				double f6 = (double) y + rand.nextFloat() * 0.5F + 0.5F;
 				double f12 = (double) z + rand.nextFloat();
-				world.spawnParticle("largesmoke", f, f6, f12, 0.0D, 0.0D, 0.0D);
+				world.spawnParticle("largesmoke", f, f6, f12, 0.0D, 0.0D, 0.0D, 0);
 			}
 
 		} else {
@@ -308,7 +308,7 @@ public class BlockFire extends Block {
 					double f1 = (double) x + rand.nextFloat() * 0.1F;
 					double f7 = (double) y + rand.nextFloat();
 					double f13 = (double) z + rand.nextFloat();
-					world.spawnParticle("largesmoke", f1, f7, f13, 0.0D, 0.0D, 0.0D);
+					world.spawnParticle("largesmoke", f1, f7, f13, 0.0D, 0.0D, 0.0D, 0);
 				}
 
 			}
@@ -317,7 +317,7 @@ public class BlockFire extends Block {
 					double f2 = (double) (x + 1) - rand.nextFloat() * 0.1F;
 					double f8 = (double) y + rand.nextFloat();
 					double f14 = (double) z + rand.nextFloat();
-					world.spawnParticle("largesmoke", f2, f8, f14, 0.0D, 0.0D, 0.0D);
+					world.spawnParticle("largesmoke", f2, f8, f14, 0.0D, 0.0D, 0.0D, 0);
 				}
 
 			}
@@ -326,7 +326,7 @@ public class BlockFire extends Block {
 					double f3 = (double) x + rand.nextFloat();
 					double f9 = (double) y + rand.nextFloat();
 					double f15 = (double) z + rand.nextFloat() * 0.1F;
-					world.spawnParticle("largesmoke", f3, f9, f15, 0.0D, 0.0D, 0.0D);
+					world.spawnParticle("largesmoke", f3, f9, f15, 0.0D, 0.0D, 0.0D, 0);
 				}
 
 			}
@@ -335,7 +335,7 @@ public class BlockFire extends Block {
 					double f4 = (double) x + rand.nextFloat();
 					double f10 = (double) y + rand.nextFloat();
 					double f16 = (double) (z + 1) - rand.nextFloat() * 0.1F;
-					world.spawnParticle("largesmoke", f4, f10, f16, 0.0D, 0.0D, 0.0D);
+					world.spawnParticle("largesmoke", f4, f10, f16, 0.0D, 0.0D, 0.0D, 0);
 				}
 
 			}
@@ -344,7 +344,7 @@ public class BlockFire extends Block {
 					double f5 = (double) x + rand.nextFloat();
 					double f11 = (double) (y + 1) - rand.nextFloat() * 0.1F;
 					double f17 = (double) z + rand.nextFloat();
-					world.spawnParticle("largesmoke", f5, f11, f17, 0.0D, 0.0D, 0.0D);
+					world.spawnParticle("largesmoke", f5, f11, f17, 0.0D, 0.0D, 0.0D, 0);
 				}
 
 			}
diff --git a/src/main/java/net/minecraft/core/block/BlockFluid.java b/src/main/java/net/minecraft/core/block/BlockFluid.java
index 9930d4175..7e695b939 100644
--- a/src/main/java/net/minecraft/core/block/BlockFluid.java
+++ b/src/main/java/net/minecraft/core/block/BlockFluid.java
@@ -212,7 +212,7 @@ public abstract class BlockFluid extends Block
             double xOff = (double) x + rand.nextFloat();
             double yOff = (double) y + maxY;
             double zOff = (double) z + rand.nextFloat();
-            world.spawnParticle("lava", xOff, yOff, zOff, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("lava", xOff, yOff, zOff, 0.0D, 0.0D, 0.0D, 0);
         }
     }
 
@@ -312,7 +312,7 @@ public abstract class BlockFluid extends Block
         world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
         for (int i = 0; i < 8; i++)
         {
-            world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + 1.2D, (double)z + Math.random(), 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + 1.2D, (double)z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
         }
     }
 }
